/* 
   Attenti all'incendio  
*/

#include <stdio.h>
#include <stdlib.h>
#include <cassert>
#include <list>

#define MAXN 100  //con 10000 non parte, app bloccata dal SO (chiede troppa ram? signal 11 (could be triggered by violating memory limits)
using namespace std;

long long int nodi[MAXN*MAXN][2];
//bool visitato[MAXN*MAXN]={false};
//int citta[MAXN][MAXN];
//list<int> grafo[MAXN*MAXN]; 
list<long long int> percorso; 
bool fine = false;

int alzati(int N, int M, int X[], int Y[]);

void DFS(int nodo, int citta[][MAXN], int N, list<int> grafo[MAXN*MAXN], bool visitato[MAXN*MAXN]) {
	
	//static bool fine = false;
		
	if (!fine) {
		//marca il nodo corrente
		visitato[nodo] = true;
		// Scorre la lista di adiacenza del nodo corrente
		while(!grafo[nodo].empty() && !fine) {

			int prossimo=grafo[nodo].front();
			grafo[nodo].pop_front();
			
			//printf("Sono sulla cella (%d,%d)\n",nodi[nodo][0],nodi[nodo][1]);
			if (nodi[nodo][0]==N-1 && nodi[nodo][1]==N-1) {
				fine = true;
				return;
			}				
			if (!visitato[prossimo]) {
				//printf("Provo con la cella (%d,%d)\n",nodi[prossimo][0],nodi[prossimo][1]);
				if(citta[nodi[prossimo][0]][nodi[prossimo][1]]==-1) {
					percorso.push_back(prossimo);
					DFS(prossimo, citta, N, grafo, visitato);
				} //else
				//	printf("Bloccato verso cella (%d,%d)\n",nodi[prossimo][0],nodi[prossimo][1]);			
			}			
		}
		if(!fine) {
			//printf(" -> C%d,%d",nodi[nodo][0],nodi[nodo][1]);
			percorso.pop_back();
		}	
	} //else
	  //	return true;
	  //return c;
}

int alzati(int N, int M, int X[], int Y[]) {
	
	int i,j,h,k,r,c;
	int citta[MAXN][MAXN];
	int u,v;
	int d=0;
	bool esiste_passaggio=true;
	
	list<int> grafo[N*N]; 
	bool visitato[N*N];
	
	for(r=0; r<N; r++) 
		for(c=0; c<N; c++)
			citta[r][c]=-1;		
	for(i=0; i<M; i++) {
		citta[X[i]][Y[i]]=0;
	}	
	//calcola per ogni cella dopo quanto tempo si brucia
	//(popola matrice riempiendo il rombo intorno ad ogni cella)
	d=0;
	do {
		//carica lista adiacenze	
		u=0;
		for (i=0; i<N; i++) {
			for (j=0; j<N; j++) {
				nodi[u][0]=i;
				nodi[u][1]=j;
				if(j<N-1) {//dx
					v=i*N+(j+1);
					grafo[u].push_back(v);
				}
				if(i<N-1) {//giu
					v=(i+1)*N+j;
					grafo[u].push_back(v);
				}
				if(j>0) {//sx
					v=i*N+(j-1);
					grafo[u].push_back(v);
				}			
				if(i>0) {//su
					v=(i-1)*N+j;
					grafo[u].push_back(v);
				}
				u++;
			}							
		}
		d++;
		for(i=0; i<M; i++) {
			//Riempi cornice rombo di "raggio" d (di distanza dal centro (x,y)) con il valore d stesso nella matrice mat nxn
			int h;
			for(h=0; h<=d; h++) {
				if(X[i]-h>=0) {
					if(Y[i]-(d-h)>=0 && citta[X[i]-h][Y[i]-(d-h)]==-1)
						citta[X[i]-h][Y[i]-(d-h)]=d;
					if(Y[i]+(d-h)<N && citta[X[i]-h][Y[i]+(d-h)]==-1)
						citta[X[i]-h][Y[i]+(d-h)]=d;
				}
				if(X[i]+h<N) {
					if(Y[i]-(d-h)>=0 && citta[X[i]+h][Y[i]-(d-h)]==-1) 
						citta[X[i]+h][Y[i]-(d-h)]=d;
					if(Y[i]+(d-h)<N && citta[X[i]+h][Y[i]+(d-h)]==-1)
						citta[X[i]+h][Y[i]-(d-h)]=d;
				}		
			}			
		}
		//DEBUG: controlla matrice
		//system("pause");	
		/*for(r=0; r<N; r++) {
			for(c=0; c<N; c++)
				printf("%d\t",citta[r][c]);
			putchar('\n');	
		}*/
		//controlla se esiste un percorso da 0,0 a n-1,n-1 		
			//prova 				
		percorso.clear();
		fine=false;
		//rendi tutti i nodi non visitati
		for (int i = 0; i < N*N; i++)
			 visitato[i]=false;
				
		DFS(0, citta, N, grafo, visitato);	
				
		if(percorso.empty())
			esiste_passaggio=false;
		else
			esiste_passaggio=true;		
					
	} while(esiste_passaggio);

	return d-1;       		
}

int main() {

  int N, M;
  
  //carica dati input
  FILE *fin,*fout;
  fin=fopen("input.txt","r");

  //assert(2==scanf("%d %d", &N, &M));
  assert(2==fscanf(fin,"%d %d", &N, &M));

  int *X = (int*) malloc(M * sizeof(int));
  int *Y = (int*) malloc(M * sizeof(int));

  for(int i=0; i<M; i++)
      //assert(2==scanf("%d %d", X+i, Y+i));
      assert(2==fscanf(fin,"%d %d", X+i, Y+i));

  fclose(fin);
  printf("%d\n", alzati(N, M, X, Y));
  return 0;
}

